package So24::DB;
our (@ISA, @EXPORT_OK);
BEGIN {
     require Exporter;
     @ISA = qw(Exporter);
     @EXPORT_OK = qw(kpdb_ips make_db_dsn);  # symbols to export on request
}

use strict;
use DBI qw(:sql_types);
use DBI qw(:utils);

use File::Temp qw/ tempfile tempdir /;




sub kpdb_ips {
	my ($dbip, $dbuser, $dbpassword, $db_options, $UserID) = @_;


        #kd_login setup
        my ($dsnloginfile, $dsnlogin) = make_db_dsn($dbip, $dbuser, $dbpassword);

        #print "DSN = $dsnlogin, dsnfile = $dsnloginfile\n";

        # Connect to login db to get path's for users
        my $dbhlogin = DBI->connect($dsnlogin, $dbuser, $dbpassword, $db_options)
                or exit_msg("Can't connect: $DBI::errstr");

	my $sth;
	if ($UserID) {
	        $sth = $dbhlogin->prepare('SELECT UserID, KPDB_IP, KPDB_DB, KPEmail_IP, KPEmail_DB, FilePath,MailPath FROM dbo.vw_SD_GetClientInfo WITH (NOLOCK) where UserID=?');
        	$sth->execute($UserID) or die $sth->errstr;
	}
	else {
	        $sth = $dbhlogin->prepare('SELECT UserID, KPDB_IP, KPDB_DB, KPEmail_IP, KPEmail_DB, FilePath,MailPath FROM dbo.vw_SD_GetClientInfo WITH (NOLOCK)');
	        $sth->execute() or die $sth->errstr;
	}
        #laster ned sql resultater
        my @ClientInfo;
        while ((my $r = $sth->fetchrow_hashref)) {
                push (@ClientInfo, $r);
        }
        $sth->finish();

	unlink($dsnloginfile) or warn("Can't unlink $dsnloginfile: $!");

	return @ClientInfo;

}

sub make_db_dsn {
        my ($ip, $user, $password, $database) = @_;

        $database = ($database or '');
        #print "make_db_dsn(ip=\"$ip\", user=\"$user\", password=\"$password\", database=\"$database\")\n";

        # Lag temporær konfig-fil:
        my $fh;
        my $filename;
        ($fh, $filename) = tempfile("freetds.XXXXX", DIR => "/tmp", UNLINK => 0);
        print $fh "[global]\n\tclient charset = UTF-8\n\ttds version = 8.0\n\ttext size = 64512\n";
        #print $fh "\tdump file = /tmp/freetds.log\n";
        print $fh "\n";
        print $fh "[24so]\n\thost = $ip\n\tport = 1433\n";
        close($fh);
        $ENV{FREETDSCONF} = $filename;

        my $dsn = join "", (
                "dbi:ODBC:",
                "DRIVER={FreeTDS};",
                "Servername=24so;",
                "UID=$user;",
                "PWD=$password;",
                );

        $dsn .= "Database=$database;" if defined $database;

        #print "FILENAME = " . $filename . "\n";
        #print "~make_db_dsn=\"$dsn\"\n";

        return ($filename, $dsn);
}

1;
