
package So24::File;

use Data::Dumper;
use DBI;
use Date::Parse;

sub new
{

    my $class = shift;
    my $self = {
	FileExplorer 	=> shift,
        FileInfo  	=> shift,

    };


	rec_path($self->{'FileExplorer'}->{'cataloges'}, \@{$self->{'catalog'}}, $self->{'FileInfo'}->{'CatalogId'});


		#printf("%-120s [%s] type=%s\n",cat_join_names(\%cataloges, \@catalog, "/") . $r2->{'Filename'}, cat_acls_names(\%cataloges, \@catalog, $r2->{'FileId'}, \%fileacl, \%catalogacl, \%groupnames), detect_24so_type(\%cataloges, $catalog[0]) );


    bless $self, $class;
    return $self;
}


sub Filename {
	my $self = shift;

	return $self->{'FileInfo'}->{'Filename'};

}

sub FileId {
	my $self = shift;

	return $self->{'FileInfo'}->{'FileId'};	
}
sub FileExt {
	my $self = shift;

	return $self->{'FileInfo'}->{'FileExt'};	
}
sub FileSize {
	my $self = shift;

	return $self->{'FileInfo'}->{'FileSize'};	
}
sub DateModified {
	my $self = shift;

	return $self->{'FileInfo'}->{'DateModified'} ? str2time($self->{'FileInfo'}->{'DateModified'}) : 0;	

}
sub FileName {
	my $self = shift;

	return $self->{'FileInfo'}->{'Filename'};	

}

sub path {
	my ($self, $exp) = @_;

	if (!$exp) {
		$exp = "\\";
	}

	#skal vi prefikse eller ikke ?
	my $path = $exp;
	#my $path = '';

	foreach my $CatalogId (@{ $self->{'catalog'} } ) {

		if ($self->{'FileExplorer'}->{'cataloges'}->{$CatalogId}->{'CatalogName'}) {
			$path .= $self->{'FileExplorer'}->{'cataloges'}->{$CatalogId}->{'CatalogName'} . $exp;
		}
		else {
			#$path .= "Unknown id:" . $CatalogId . $exp;
		}
	}

	return $path;
}


sub type {
	my ($self) = @_;


	if ($self->{'FileInfo'}->{'CatalogId'} == 0) {
		# file is on the root system. No subcatahpry is to be found, but that is ok, and by design
	}
	elsif (!$self->{'FileExplorer'}->{'cataloges'}->{$self->{'catalog'}->[0]}) {
		warn("Unknown catalog! FileId: " . $self->FileId . ". Cat id: " . Dumper($self->{'catalog'}) );
	}



	if (($self->{'FileExplorer'}->{'cataloges'}->{$self->{'catalog'}->[0]}->{'ParentId'} == 0) 
			&& $self->{'FileExplorer'}->{'cataloges'}->{$self->{'catalog'}->[0]}->{'CustomerId'}) {
		# CRM
		return "crm";
	}
	elsif (($self->{'FileExplorer'}->{'cataloges'}->{$self->{'catalog'}->[0]}->{'ParentId'} == 0) 
			&& $self->{'FileExplorer'}->{'cataloges'}->{$self->{'catalog'}->[0]}->{'ContactId'}) {
		#CONTACTS
		return "contact";
	}
	elsif (($self->{'FileExplorer'}->{'cataloges'}->{$self->{'catalog'}->[0]}->{'ParentId'} == 0)
			&& $self->{'FileExplorer'}->{'cataloges'}->{$self->{'catalog'}->[0]}->{'ProjectId'}) {
		#PROJECTS
		return "project";
	}
	elsif (($self->{'FileExplorer'}->{'cataloges'}->{$self->{'catalog'}->[0]}->{'ParentId'} == 0) 
			&& $self->{'FileExplorer'}->{'cataloges'}->{$self->{'catalog'}->[0]}->{'EmployeeId'}) {
		#MY DOCUMENTS
		return "mydocuments";
	}
	elsif (($self->{'FileExplorer'}->{'cataloges'}->{$self->{'catalog'}->[0]}->{'ParentId'} == 0) 
			&& ($self->{'FileExplorer'}->{'cataloges'}->{$self->{'catalog'}->[0]}->{'IsTemplate'} == 1)) {
		#MY TEMPLATE
		return "template";
	}
	elsif (($self->{'FileExplorer'}->{'cataloges'}->{$self->{'catalog'}->[0]}->{'ParentId'} == 0) 
		&& !$self->{'FileExplorer'}->{'cataloges'}->{$self->{'catalog'}->[0]}->{'EmployeeId'}
		&& !$self->{'FileExplorer'}->{'cataloges'}->{$self->{'catalog'}->[0]}->{'CustomerId'}
		&& !$self->{'FileExplorer'}->{'cataloges'}->{$self->{'catalog'}->[0]}->{'ContactId'}
		&& !$self->{'FileExplorer'}->{'cataloges'}->{$self->{'catalog'}->[0]}->{'ProjectId'}
		&& !$self->{'FileExplorer'}->{'cataloges'}->{$self->{'catalog'}->[0]}->{'ProductId'}
		&& ($self->{'FileExplorer'}->{'cataloges'}->{$self->{'catalog'}->[0]}->{'IsTemplate'} == 0)
		&& ($self->{'FileExplorer'}->{'cataloges'}->{$self->{'catalog'}->[0]}->{'DeletedType'} == 0)
	) {
		#Explorer files
		return "explorerfiles";
		}
	else {
		return undef;
		}

}


sub attribSafe {
	my $a = shift;

	$a =~ s/[,=]/ /g;

	return $a;

}

sub attribCustomer {
	my ($self) = @_;

	my $attribs;

	my $sth = $self->{'FileExplorer'}->{'dbh'}->prepare(qq{
		SELECT 
			[CustomerId],
	      		[CompanyName],
		      	[CompanyNickName],
		      	[Company],
			[Orgnr],
      			[Private],
      			[EmployeeId]
		FROM 
			[KPAdmin].[CRM_Customer] WITH(NOLOCK)
		WHERE 
			UserID = ? 
			AND CustomerId=?
	});
	$sth->execute($self->{'FileExplorer'}->{'UserID'},  $self->{'FileExplorer'}->{'cataloges'}->{ $self->{'catalog'}->[0] }->{'CustomerId'} ) or die("Error execute: $!");
	while ((my $r = $sth->fetchrow_hashref)) {
       	        #print Dumper($r), "\n";
		$attribs->{'CusId'} 	 = attribSafe( $r->{'CustomerId'} ) if $r->{'CustomerId'};
		$attribs->{'CusName'} 	 = attribSafe( $r->{'CompanyName'} ) if $r->{'CompanyName'};
		$attribs->{'CusNick'} 	 = attribSafe( $r->{'CompanyNickName'} ) if $r->{'CompanyNickName'};
		$attribs->{'CusIsCompany'} = attribSafe( $r->{'Company'} ) if $r->{'Company'};
		$attribs->{'CusOrgnr'} 	 = attribSafe( $r->{'Orgnr'} ) if $r->{'Orgnr'};
		$attribs->{'Private'} 	 = attribSafe( $r->{'Private'} ) if $r->{'Private'};
		$attribs->{'EmployeeId'} 	 = attribSafe( $r->{'EmployeeId'} ) if $r->{'EmployeeId'};
       	}

	return $attribs;
}

sub attribProject {
	my ($self) = @_;

	my $attribs;

	my $sth = $self->{'FileExplorer'}->{'dbh'}->prepare(qq{
		SELECT 
			[ProjectId],[ProjectName]
  		FROM 
			[KPAdmin].[CRM_Project] WITH(NOLOCK)
		WHERE 
			UserID = ?
			AND ProjectId = ?
	});
	$sth->execute($self->{'FileExplorer'}->{'UserID'},  $self->{'FileExplorer'}->{'cataloges'}->{ $self->{'catalog'}->[0] }->{'ProjectId'} ) or die("Error execute: $!");
	while ((my $r = $sth->fetchrow_hashref)) {
       	        #print Dumper($r), "\n";
		$attribs->{'ProId'} 	= attribSafe( $r->{'ProjectId'} ) if $r->{'ProjectId'};
		$attribs->{'ProName'} 	= attribSafe( $r->{'ProjectName'} ) if $r->{'ProjectName'};
       	}

	return $attribs;
}

sub attribContact {
	my ($self) = @_;

	my $attribs;

	my $sth = $self->{'FileExplorer'}->{'dbh'}->prepare(qq{
		SELECT 
		     	[Firstname],
			[Lastname],
			[ContactId],
			[EmployeeId],
			[Private]
  		FROM 
			[KPAdmin].[CRM_Contact] WITH(NOLOCK)
		WHERE 
			UserID = ? 
			AND ContactId = ?
	});
	$sth->execute($self->{'FileExplorer'}->{'UserID'},  $self->{'FileExplorer'}->{'cataloges'}->{ $self->{'catalog'}->[0] }->{'ContactId'} ) or die("Error execute: $!");
	while ((my $r = $sth->fetchrow_hashref)) {
       	        #print Dumper($r), "\n";
		if ($r->{'Firstname'} && $r->{'Lastname'}) {
			$attribs->{'ConName'} = attribSafe( $r->{'Firstname'} . " " . $r->{'Lastname'} );
		}
		elsif($r->{'Firstname'}) {
			$attribs->{'ConName'} = attribSafe( $r->{'Firstname'} );
		}
		elsif($r->{'Lastname'}) {
			$attribs->{'ConName'} = attribSafe( $r->{'Lastname'} );
		}

		$attribs->{'ConId'} = attribSafe( $r->{'ContactId'} ) if $r->{'ContactId'};
		$attribs->{'Private'} = attribSafe( $r->{'Private'} ) if $r->{'Private'};
		$attribs->{'EmployeeId'} = attribSafe( $r->{'EmployeeId'} ) if $r->{'EmployeeId'};
       	}

	return $attribs;
}

sub attrib {
	my ($self) = @_;

	my $attribs;
	if($self->{'attrib_cache'}->{$self->{'FileExplorer'}->{'cataloges'}->{ $self->{'catalog'}->[0] }->{'CustomerId'} }) {
		$attribs = $self->{'attrib_cache'}->{$self->{'FileExplorer'}->{'cataloges'}->{ $self->{'catalog'}->[0] }->{'CustomerId'} };
	
		return $attribs;
	}

	if($self->type eq "explorerfiles") {
		# mark as 24so file
	}
	elsif($self->type eq "crm") {

		$attribs = $self->attribCustomer;
	}
	elsif($self->type eq "contact") {

		$attribs = $self->attribContact;
	}
	elsif($self->type eq "project") {

		$attribs = $self->attribProject;
	}
	elsif($self->type eq "template") {
	}
	elsif($self->type eq "mydocuments") {
	}
	else {
		warn("Unknow file type! Catalog: " . Dumper($self->{'catalog'}));
	}

	$attribs->{'FileSize'} 	= attribSafe( $self->{'FileInfo'}->{'FileSize'} ) if $self->{'FileInfo'}->{'FileSize'};
	$attribs->{'Type'} 	= attribSafe( $self->type ) if $self->type;
	$attribs->{'Path'} 	= attribSafe( $self->path ) if $self->path;

	$attribs->{'File'} 	= "24so";



	$self->{'attrib_cache'}->{$self->{'FileExplorer'}->{'cataloges'}->{ $self->{'catalog'}->[0] }->{'CustomerId'}} = $attribs;

	return $attribs;

}

sub db_acl {
	my ($self) = @_;

	my @acl;

        foreach my $r (@{ $self->{'FileExplorer'}->{'db_acl'}->{ $self->{'FileInfo'}->{'FileId'} }}) {
		push(@acl, $r->{'Id'} );
        }

        foreach my $index (0 .. $#acl) {
		if ($self->{'FileExplorer'}->{'groupnames'}->{$acl[$index]} ) {

			$acl[$index] = $self->{'FileExplorer'}->{'UserID'} . "-g-" . $self->{'FileExplorer'}->{'groupnames'}->{$acl[$index]};
		}
		else {
			$acl[$index] = $self->{'FileExplorer'}->{'UserID'} . "-" . $acl[$index]; 
		}
        }

	return join(",",@acl);

}

sub acl {
	my ($self) = @_;

	my @acl;
	my @aclpath;

	#die ("Acl is depricated. Use db_acl!");

	if($self->type eq "mydocuments") {
		return $self->{'FileExplorer'}->{'UserID'} . "-" . $self->{'FileExplorer'}->{'cataloges'}->{$self->{'catalog'}->[0]}->{'EmployeeId'};
	}

	# if this is a privat custumer (crm) or contact, set acl to owner
	if($self->type eq "crm" || $self->type eq "contact") {
		$attribs = $self->attrib;

		if ($attribs->{'Private'} && $attribs->{'Private'}!=0) {
			return $self->{'FileExplorer'}->{'UserID'} . "-" . $attribs->{'EmployeeId'};
		}
	}

	# create the acl path
	# Adding catalogs
	foreach my $CatalogId (@{ $self->{'catalog'} }) {
		if (!$self->{'FileExplorer'}->{'catalogacl'}->{$CatalogId} ) {next;}
		push(@aclpath, $self->{'FileExplorer'}->{'catalogacl'}->{$CatalogId} );

	}
	# if we have fileacl, add it
	if ($self->{'FileExplorer'}->{'fileacl'}->{$self->{'FileInfo'}->{'FileId'}}) {
		push(@aclpath, $self->{'FileExplorer'}->{'fileacl'}->{$self->{'FileInfo'}->{'FileId'}} );
	}

	# if we dident have any acl's return company id (24so's "everyone").
	if ($#aclpath == -1) {
		return $self->{'FileExplorer'}->{'UserID'};
	}

	foreach my $CatalogAcl ( @aclpath  ) {
		#print "CatalogAcl: ", Dumper($CatalogAcl);
		if (!@acl) {
			# Don't have any data from before. Adding first acl.
			if ($CatalogAcl) {
				@acl = @{$CatalogAcl};
			}
		}	
		else {
			my %tmp;
			my @tacl;
			foreach my $s ( @{$CatalogAcl} ) {$tmp{$s} = 1;}

			foreach my $index (0 .. $#acl) {
				if ($tmp{$acl[$index]} == 1) {
					#print "drop $acl[$index]\n";
					#delete $acl[$index];
					#@acl = splice(@acl,$index,1);
					push(@tacl, $acl[$index]);
				}
				
			}

			@acl = @tacl;
			if ($#acl==-1) {
				push(@acl,"-1");
			}
		}
	}

	foreach my $index (0 .. $#acl) {
		if ($self->{'FileExplorer'}->{'groupnames'}->{$acl[$index]}) {
			$acl[$index] = $self->{'FileExplorer'}->{'UserID'} . "-g-" . $self->{'FileExplorer'}->{'groupnames'}->{$acl[$index]};
		}
		else {
			$acl[$index] = $self->{'FileExplorer'}->{'UserID'} . $self->{'FileExplorer'}->{'groupnames'}->{$acl[$index]};
		}
	}
	
	#print Dumper(\@acl);

	return join(",",@acl);
}
sub  rec_path {
	my ($cataloges, $catalog, $CatalogId) = @_;
	if ($CatalogId == 0) {return; }
	if ($catalog && (scalar(@{ $catalog}) > 20)) {warn ("Posible sircular catalog $CatalogId"); return; }
	#printf("rec_path(CatalogId=%s)(name=%s)\n", $CatalogId, $cataloges->{$CatalogId}->{'CatalogName'});

	unshift( @{ $catalog }, $CatalogId);

	rec_path($cataloges, $catalog, $cataloges->{$CatalogId}->{'ParentId'});

}



1;
