package So24::FileExplorer;

use DBI;
use POSIX qw(strftime);
use So24::File;
use Data::Dumper;

sub new
{
        my $class = shift;
        my $self = {
            dbh => shift,
            UserID  => shift,
	    lastcrawl => shift
        };

        #print "conected\n";

	# geting all catalogs
	#my %cataloges;
	my $sth = $self->{'dbh'}->prepare("SELECT CatalogId, CatalogName, ParentId,UserId, ParentId, EmployeeId, CustomerId,ContactId,ProjectId,ProductId,IsTemplate,DeletedType FROM [KPAdmin].[Explorer_Catalogs] WITH(NOLOCK) where UserID = ?");
	$sth->execute($self->{'UserID'}) or die("Error execute: $!");
	while ((my $r = $sth->fetchrow_hashref)) {
                #print Dumper($r), "\n";
		$self->{'cataloges'}{$r->{'CatalogId'}} = $r;
        }

	# geting acl for files
	#my %fileacl;
	my $sth = $self->{'dbh'}->prepare("SELECT [FileId],[GroupId],[ChainId],[ParentId],[DateReg] FROM [KPAdmin].[Chain_Access_Files] WITH(NOLOCK) where ParentId = ?");
	$sth->execute($self->{'UserID'}) or die("Error execute: $!");
	while ((my $r = $sth->fetchrow_hashref)) {
		#print Dumper($r);
		push(@{ $self->{'fileacl'}{$r->{'FileId'}} }, $r->{'GroupId'});
        }
	#print Dumper(\%fileacl);


	# geting acl for catalogs
	#my %catalogacl;
	my $sth = $self->{'dbh'}->prepare("SELECT [CatalogId],[GroupId],[DateReg] FROM [KPAdmin].[Chain_Access_ExplorerCatalogs] WITH(NOLOCK) where ParentId = ?");
	$sth->execute($self->{'UserID'}) or die("Error execute: $!");
	while ((my $r = $sth->fetchrow_hashref)) {
		push(@{ $self->{'catalogacl'}{$r->{'CatalogId'}} }, $r->{'GroupId'});
        }
	#print Dumper(\%catalogacl);

	
	# geting alc from the new Jrn db table.
	my $sth = $self->{'dbh'}->prepare("SELECT [UserId],[FileId],[Id],[ModuleID],[DateReg] FROM [dbo].[Explorer_Files_ACL] WITH(NOLOCK) where UserID = ?");
	$sth->execute($self->{'UserID'}) or die("Error execute: $!");
	while ((my $r = $sth->fetchrow_hashref)) {
		push(@{ $self->{'db_acl'}{$r->{'FileId'}} }, $r);
        }
	#print Dumper( $self->{'db_acl'});
	

	#geting group names
	#my %groupnames;
	my $sth = $self->{'dbh'}->prepare("SELECT [GroupId],[GroupName] FROM [KPAdmin].[Groups] WITH(NOLOCK) WHERE UserID = ?");
	$sth->execute($self->{'UserID'}) or die("Error execute: $!");
	while ((my $r = $sth->fetchrow_hashref)) {
		$self->{'groupnames'}{$r->{'GroupId'}} = $r->{'GroupName'};
        }
	#print Dumper(\%groupnames);

    	bless $self, $class;
    	return $self;
}

sub listNewFiles {
	my $self = shift;

	# Geting new files
        my $sth = $self->{'dbh'}->prepare(qq{
                                        SELECT  DISTINCT
                                                Explorer_Files.UserId,
                                                Explorer_Files.FileId,
                                                Explorer_Files.DateCreated,
                                                Explorer_Files.FileExt,
                                                Explorer_Files.UserId,
                                                Explorer_Files.CatalogId,
                                                Explorer_Files.FileSize,
                                                Modul = convert(varchar(20), 'Explorer'),
                                                Filename = FileName collate Danish_Norwegian_CI_AS + '.' + Fileext,
                                                DateModified = CASE WHEN Explorer_Files_ACL.DateReg>Explorer_Files.DateModified THEN Explorer_Files_ACL.DateReg ELSE Explorer_Files.DateModified END
                                        FROM
                                                Explorer_Files_ACL, [KPAdmin].Explorer_Files WITH(NOLOCK)
                                        WHERE
						Explorer_Files_ACL.FileId=Explorer_Files.FileId
                                                AND Explorer_Files.DeletedType = 0
                                                AND (Explorer_Files_ACL.DateReg > convert(datetime, ?, 120) OR Explorer_Files.DateModified > convert(datetime,?, 120))
                                                AND Explorer_Files.Userid = ?
               				} );
	$sth->execute(POSIX::strftime( "%Y-%m-%d %T", localtime( $self->{'lastcrawl'} ) ), POSIX::strftime( "%Y-%m-%d %T", localtime( $self->{'lastcrawl'} ) ),$self->{'UserID'}) or die("Error execute: $!");

	my @newfiles;
        while ((my $r2 = $sth->fetchrow_hashref)) {
		#my @catalog;
		#
		push(@newfiles, $r2);

        }

	return @newfiles;

}

sub popNewFiles {
        my $self = shift;

	if (!$self->{'popNewFilesSet'}) {
		@{ $self->{'popNewFilesSet'} } = $self->listNewFiles();
	}

	if (scalar(@{$self->{'popNewFilesSet'}}) == 0) {
		return undef;
	}

	return So24::File->new($self, pop( @{ $self->{'popNewFilesSet'} } ) );

}

sub module2Type {
	my $modul = shift;

	return 'explorerfiles' if ($modul eq 'Explorer root');
	return 'explorerfiles' if ($modul eq 'Explorer');
	return 'mydocuments' if ($modul eq 'My Documents');
	return 'crm' if ($modul eq 'CRM - Customer');
	return 'crm' if ($modul eq 'CRM - Contact');
	return 'crm' if ($modul eq 'CRM - Project');

	return undef;
}

sub listDeletedFiles {
	my $self = shift;

	# Geting new files
        my $sth = $self->{'dbh'}->prepare(qq{
					SELECT 
						FileId, 
						Modul 
					FROM 
						Explorer_Files_Deleted WITH (NOLOCK) 
					WHERE 	
						DateDeleted > convert(datetime, ?, 120) 
						AND UserId = ?
				} );
	$sth->execute(POSIX::strftime( "%Y-%m-%d %T", localtime( $self->{'lastcrawl'} ) ), $self->{'UserID'}) or die("Error execute: $!");

	my @delfiles;

        while ((my $r2 = $sth->fetchrow_hashref)) {
		$r2->{'type'} = module2Type( $r2->{'Modul'} );
		push(@delfiles, $r2);
        }

	return @delfiles;

}

sub popDeletedFiles {
        my $self = shift;

	if (!$self->{'popDeletedFilesSet'}) {
		@{ $self->{'popDeletedFilesSet'} } = $self->listDeletedFiles();
	}

	if (scalar(@{$self->{'popDeletedFilesSet'}}) == 0) {
		return undef;
	}

	return  pop( @{ $self->{'popDeletedFilesSet'} } );
	#return So24::File->new($self, pop( @{ $self->{'popDeletedFilesSet'} } ) );

}

sub listAclChangedFiles {
	my $self = shift;


	#Geting the ModuleId -> ModuleDesc
        my $sth = $self->{'dbh'}->prepare(qq{
					SELECT 
						ModuleId,
						ModuleDesc
					FROM 
						Explorer_Files_ACL_Modules WITH (NOLOCK) 
				} );

	$sth->execute() or die("Error execute: $!");

	my %ModuleDesc;
        while ((my $r2 = $sth->fetchrow_hashref)) {
		$ModuleDesc{ $r2->{'ModuleId'} } = $r2->{'ModuleDesc'};
	}	

	# Geting new files
       	my $sth = $self->{'dbh'}->prepare(qq{
					SELECT DISTINCT
						[Kontorplassen].[dbo].[Explorer_Files_ACL_FileStatus].[FileId],
						[ModuleId]

					FROM 
						[Kontorplassen].[dbo].[Explorer_Files_ACL_FileStatus],[Kontorplassen].[dbo].[Explorer_Files_ACL] WITH (NOLOCK)
					WHERE 	
						[Kontorplassen].[dbo].[Explorer_Files_ACL_FileStatus].FileId=[Kontorplassen].[dbo].[Explorer_Files_ACL].FileId
						AND [Kontorplassen].[dbo].[Explorer_Files_ACL_FileStatus].Status = 2
						AND [Kontorplassen].[dbo].[Explorer_Files_ACL].DateReg > convert(datetime, ?, 120) 
						AND [Kontorplassen].[dbo].[Explorer_Files_ACL].UserId = ?
				} );
	$sth->execute(POSIX::strftime( "%Y-%m-%d %T", localtime( $self->{'lastcrawl'} ) ), $self->{'UserID'}) or die("Error execute: $!");


	my @aclChangedfiles;
       	while ((my $r2 = $sth->fetchrow_hashref)) {
		# Find the type
		$r2->{'type'} = module2Type( $ModuleDesc{ $r2->{'ModuleId'} } );
		push(@aclChangedfiles, $r2);
       	}

	return @aclChangedfiles;

}

sub popAclChangedFiles {
        my $self = shift;

	if (!$self->{'popAclChangedFilesSet'}) {
		@{ $self->{'popAclChangedFilesSet'} } = $self->listAclChangedFiles();
	}

	if (scalar(@{$self->{'popAclChangedFilesSet'}}) == 0) {
		return undef;
	}

	return  pop( @{ $self->{'popAclChangedFilesSet'} } );
	#return So24::File->new($self, pop( @{ $self->{'popAclChangedFilesSet'} } ) );

}

1;
